<template>
    <LeftSideBarComponent ref="LeftSideBarComponent" :layoutTheme="this"></LeftSideBarComponent>
    <Topbar ref="Topbar"></Topbar>
    <RightBar ref="RightBar"></RightBar>
</template>

<script>
import LeftSideBarComponent from "./LeftSideBarComponent";
import Topbar from "./Topbar";
import RightBar from './RightBar';

export default {
    name: "LayoutThemeApp",

    props: ['rightBarComponent'],

    components:{
        LeftSideBarComponent,
        Topbar,
        RightBar
    },

    data(){
        return {
            body: $('body'),
            window:  $(window),
            config: {},
            // styles
            defaultBSStyle: $("#bs-default-stylesheet"),
            defaultAppStyle: $("#app-default-stylesheet"),
            darkBSStyle: $("#bs-dark-stylesheet"),
            darkAppStyle: $("#app-dark-stylesheet"),
        }
    },
    methods:{
        _saveConfig(newConfig) {
            this.config = $.extend(this.config, newConfig);
            // NOTE: You can make ajax call here to save preference on server side or localstorage as well
        },

        /**
         * Update the config for given config
         * @param {*} param
         * @param {*} config
         */
        updateConfig(param, config) {
            var newObj = {};
            if (typeof config === 'object' && config !== null) {
                var originalParam = this.config[param];
                newObj[param] = $.extend(originalParam, config);
            } else {
                newObj[param] = config;
            }
            this._saveConfig(newObj);
        },

        /**
         * Loads the config - takes from body if available else uses default one
         */
        loadConfig() {
            var bodyConfig = JSON.parse(this.body.attr('data-layout') ? this.body.attr('data-layout') : '{}');

            var config = $.extend({}, {
                mode: "light",
                width: "fluid",
                menuPosition: 'fixed',
                sidebar: {
                    color: "light",
                    size: "default",
                    showuser: false
                },
                topbar: {
                    color: "dark"
                },
                showRightSidebarOnPageLoad: false
            });
            if (bodyConfig) {
                config = $.extend({}, config, bodyConfig);
            };
            return config;
        },

        /**
         * Apply the config
         */
        applyConfig() {
            // getting the saved config if available
            this.config = this.loadConfig();

            // activate menus
            this.leftSidebar.init();
            this.topbar.init();

            this.leftSidebar.parent = this;
            this.topbar.parent = this;


            // mode
            this.changeMode(this.config.mode);

            // width
            this.changeLayoutWidth(this.config.width);

            // menu position
            this.changeMenuPositions(this.config.menuPosition);

            // left sidebar
            var sidebarConfig = $.extend({}, this.config.sidebar);
            this.leftSidebar.changeColor(sidebarConfig.color);
            this.leftSidebar.changeSize(sidebarConfig.size);
            this.leftSidebar.showUser(sidebarConfig.showuser);

            // topbar
            var topbarConfig = $.extend({}, this.config.topbar);
            this.topbar.changeColor(topbarConfig.color);
        },

        /**
         * Toggle dark or light mode
         * @param {*} mode
         */
        changeMode(mode) {
            // sets the theme
            switch (mode) {
                case "dark": {
                    this.defaultBSStyle.attr("disabled", true);
                    this.defaultAppStyle.attr("disabled", true);

                    this.darkBSStyle.attr("disabled", false);
                    this.darkAppStyle.attr("disabled", false);

                    this.leftSidebar.changeColor("dark");
                    this._saveConfig({ mode: mode, sidebar: $.extend({}, this.config.sidebar, { color: 'dark' }) });
                    break;
                }
                default: {
                    this.defaultBSStyle.attr("disabled", false);
                    this.defaultAppStyle.attr("disabled", false);

                    this.darkBSStyle.attr("disabled", true);
                    this.darkAppStyle.attr("disabled", true);
                    this.leftSidebar.changeColor("light");
                    this._saveConfig({ mode: mode, sidebar: $.extend({}, this.config.sidebar, { color: 'light' }) });
                    break;
                }
            }

            this.$refs.RightBar.selectOptionsFromConfig(this.getConfig());
        },

        /**
         * Changes the width of layout
         */
        changeLayoutWidth(width) {
            switch (width) {
                case "boxed": {
                    this.body.attr('data-layout-width', 'boxed');
                    // automatically activating condensed
                    this.$refs.LeftSideBarComponent.changeSize("condensed");
                    this._saveConfig({ width: width });
                    break;
                }
                default: {
                    this.body.attr('data-layout-width', 'fluid');
                    // automatically activating provided size
                    var bodyConfig = JSON.parse(this.body.attr('data-layout') ? this.body.attr('data-layout') : '{}');
                    this.$refs.LeftSideBarComponent.changeSize(bodyConfig && bodyConfig.sidebar ? bodyConfig.sidebar.size : "default");
                    this._saveConfig({ width: width });
                    break;
                }
            }
            this.$refs.RightBar.selectOptionsFromConfig(this.getConfig());
        },

        /**
         * Changes menu positions
         */
        changeMenuPositions(position) {
            this.body.attr("data-layout-menu-position", position);
        },

        /**
         * Clear out the saved config
         */
       clearSavedConfig() {
            this.config = {};
        },

        /**
         * Gets the config
         */
        getConfig() {
            return this.config;
        },

        /**
         * Reset to default
         */
        reset() {
            this.clearSavedConfig();
            this.applyConfig();
        },

        /**
         * Init
         */
        init() {
            this.leftSidebar = this.$refs.LeftSideBarComponent;
            this.topbar = this.$refs.Topbar;

            this.leftSidebar.parent = this;
            this.topbar.parent = this;

            // initilize the menu
            this.applyConfig();
        },
    },

}
</script>
